Index: /trunk/sources/HeuristicLab.Clients.Hive.Administrator/3.3/Plugin.cs.frame
===================================================================
--- /trunk/sources/HeuristicLab.Clients.Hive.Administrator/3.3/Plugin.cs.frame	(revision 6978)
+++ /trunk/sources/HeuristicLab.Clients.Hive.Administrator/3.3/Plugin.cs.frame	(revision 6979)
@@ -25,19 +25,13 @@
   [Plugin("HeuristicLab.Clients.Hive.Administrator", "3.3.5.$WCREV$")]
   [PluginFile("HeuristicLab.Clients.Hive.Administrator-3.3.dll", PluginFileType.Assembly)]
-  [PluginDependency("HeuristicLab.Clients.Common", "3.3")]
   [PluginDependency("HeuristicLab.Collections", "3.3")]
   [PluginDependency("HeuristicLab.Common", "3.3")]
-  [PluginDependency("HeuristicLab.Common.Resources", "3.3")]
   [PluginDependency("HeuristicLab.Core", "3.3")]
-  [PluginDependency("HeuristicLab.Core.Views", "3.3")]
-  [PluginDependency("HeuristicLab.Data", "3.3")]
+  [PluginDependency("HeuristicLab.Core.Views", "3.3")]  
   [PluginDependency("HeuristicLab.Clients.Hive", "3.3")]
   [PluginDependency("HeuristicLab.Clients.Hive.Views", "3.3")]
-  [PluginDependency("HeuristicLab.Optimization", "3.3")]
   [PluginDependency("HeuristicLab.Optimizer", "3.3")]
-  [PluginDependency("HeuristicLab.Persistence", "3.3")]
   [PluginDependency("HeuristicLab.MainForm", "3.3")]
-  [PluginDependency("HeuristicLab.MainForm.WindowsForms", "3.3")]
-  [PluginDependency("HeuristicLab.DayView", "1.0")]
+  [PluginDependency("HeuristicLab.MainForm.WindowsForms", "3.3")]  
   public class HeuristicLabClientsHiveAdministratorPlugin : PluginBase {
   }
Index: /trunk/sources/HeuristicLab.Clients.Hive.JobManager/3.3/Plugin.cs.frame
===================================================================
--- /trunk/sources/HeuristicLab.Clients.Hive.JobManager/3.3/Plugin.cs.frame	(revision 6978)
+++ /trunk/sources/HeuristicLab.Clients.Hive.JobManager/3.3/Plugin.cs.frame	(revision 6979)
@@ -29,14 +29,10 @@
   [PluginDependency("HeuristicLab.Collections", "3.3")]
   [PluginDependency("HeuristicLab.Common", "3.3")]
-  [PluginDependency("HeuristicLab.Common.Resources", "3.3")]
   [PluginDependency("HeuristicLab.Core", "3.3")]
   [PluginDependency("HeuristicLab.Core.Views", "3.3")]
-  [PluginDependency("HeuristicLab.Data", "3.3")]  
-  [PluginDependency("HeuristicLab.Hive", "3.3")]
   [PluginDependency("HeuristicLab.MainForm", "3.3")]
   [PluginDependency("HeuristicLab.MainForm.WindowsForms", "3.3")]
   [PluginDependency("HeuristicLab.Optimization", "3.3")]
   [PluginDependency("HeuristicLab.Optimizer", "3.3")]
-  [PluginDependency("HeuristicLab.Persistence", "3.3")]    
   public class HeuristicLabClientsHiveJobManagerPlugin : PluginBase {
   }
Index: /trunk/sources/HeuristicLab.Clients.Hive.Views/3.3/Plugin.cs.frame
===================================================================
--- /trunk/sources/HeuristicLab.Clients.Hive.Views/3.3/Plugin.cs.frame	(revision 6978)
+++ /trunk/sources/HeuristicLab.Clients.Hive.Views/3.3/Plugin.cs.frame	(revision 6979)
@@ -34,12 +34,8 @@
   [PluginDependency("HeuristicLab.Common.Resources", "3.3")]
   [PluginDependency("HeuristicLab.Core", "3.3")]
-  [PluginDependency("HeuristicLab.Core.Views", "3.3")]
-  [PluginDependency("HeuristicLab.Data", "3.3")]  
-  [PluginDependency("HeuristicLab.Hive", "3.3")]
+  [PluginDependency("HeuristicLab.Core.Views", "3.3")]  
   [PluginDependency("HeuristicLab.MainForm", "3.3")]
   [PluginDependency("HeuristicLab.MainForm.WindowsForms", "3.3")]
-  [PluginDependency("HeuristicLab.Optimization", "3.3")]
-  [PluginDependency("HeuristicLab.Optimizer", "3.3")]
-  [PluginDependency("HeuristicLab.Persistence", "3.3")]  
+  [PluginDependency("HeuristicLab.Optimization", "3.3")]     
   [PluginDependency("HeuristicLab.Visualization.ChartControlsExtensions", "3.3")]
   public class HeuristicLabClientsHiveViewsPlugin : PluginBase {
Index: /trunk/sources/HeuristicLab.Clients.Hive/3.3/Plugin.cs.frame
===================================================================
--- /trunk/sources/HeuristicLab.Clients.Hive/3.3/Plugin.cs.frame	(revision 6978)
+++ /trunk/sources/HeuristicLab.Clients.Hive/3.3/Plugin.cs.frame	(revision 6979)
@@ -34,6 +34,5 @@
   [PluginDependency("HeuristicLab.Common.Resources", "3.3")]
   [PluginDependency("HeuristicLab.Core", "3.3")]  
-  [PluginDependency("HeuristicLab.Hive", "3.3")]
-  [PluginDependency("HeuristicLab.Data", "3.3")]
+  [PluginDependency("HeuristicLab.Hive", "3.3")]  
   [PluginDependency("HeuristicLab.Optimization", "3.3")]
   [PluginDependency("HeuristicLab.Persistence", "3.3")]